
class piximage {

  PImage im;

  color couleur;
  float luminosite;
  float bleu;
  float rouge;
  float vert;

  int im_x;
  int im_y;

  int x=0;
  int y=0;

  float l, h;
  float ratio;
  float multiplicateur;



  piximage(String source, int x, int y, int largeur, int hauteur) {
    im=loadImage(source);
    this.im_x=x;
    this.im_y=y;
    

    println (im.width+" " +im.height);
    // calcul de l'image d'après les proportions données
    ratio=(largeur*1.0) / hauteur;
    float ratioi=(im.width*1.0)/im.height;

    println(ratio + " et " + ratioi);
    if (ratio >= ratioi) {
      println("ratio superieur");
      l=float(hauteur)*ratioi;
      h=hauteur;
      multiplicateur=(largeur*1.0)/im.height;
    } else {
      println("ratio inferieur");
      l=largeur;
      h=float(largeur)/ratioi;
      multiplicateur=(largeur*1.0)/im.width;
    }


    println(l + " / " + h);
    println("multiplicateur "+multiplicateur);
  }

  void afficher() {
    // afficher l'iage
    image(im, im_x, im_y, l, h);

    // afficher le rectangle de suivi
    fill(0, 255, 0, 150);
    rect(im_x+(x*multiplicateur)-1, im_y+(y*multiplicateur)-1, multiplicateur+2, multiplicateur+2);
  }

  void next_pix() {
    x+=1;
    if (x>=im.width) {
      x=0;
      y+=1;
      if (y>=im.height) {
        y=0;
        println("fin de l'image, retour au début");
      }
    }
    sample_pixel();
  }

  void next_row() {
    y+=1;
    if (y>height) {
      y=0;
      println("fin de l'image, retour au début");
    }
    sample_pixel();
  }

  void sample_pixel() {
    color c=im.get(x, y);
    rouge = c >> 16 & 0xFF;
    vert = c >> 8 & 0xFF;
    bleu = c & 0xFF;
    luminosite=brightness(c);
  }
}


// liste_fichiers(nom du dossier, extension a filtrer separés par des |);
import java.io.File; // necessaire seulement depuis la version 2b07 !


// renvoie un array de string
class liste_fichiers {
 String extension;
 String[] fichiers;
 String dossier;
 int nb_items;
 
 //constructeur
 liste_fichiers(String dossier, String extension){
   this.dossier=dossier;
   this.extension=extension;
   println("je cherche dans "+sketchPath(dossier));
   fichiers = listFileNames(sketchPath(dossier), extension);
   nb_items=fichiers.length;
   println(fichiers.length + " elements dans le dossier " + sketchPath(dossier));
 }
 
 // listage le contenu d'un dossier en ne prenant que les extensions fournies -------------------------
 String[] listFileNames(String dir, String extension) {
   File file = new File(dir);
   if (file.isDirectory()) {
     String names[] = file.list();

     // procedure d'elimination des fichiers non concernés
     String[] names_ok= {};
     for(int i=0; i<names.length;i++) {
       String[] m1 = match(names[i], extension);
       if (m1 != null) {
         names_ok=append(names_ok,dossier+"/"+names[i]);
       }
     }
     return names_ok;
   }
   else {
     // If it's not a directory
     println("le nom fourni n'est pas celui d'un dossier");
     return null;
   }
 }
}