/* jouer un son en modifiant sa vitesse en fonction de la luminosité des pixels */
piximage i;
import processing.sound.*;
SoundFile musique;

float vitesse=1;

String m="Yesterday.mp3"; // nom du fichier son
String image_source="Nuages-1.jpg"; // le nom de l'image à placer dans le dossier

void setup() {
  size(700, 700);
  i=new piximage(image_source, 10, 10, width-20, height-20);
  musique = new SoundFile(this, m);
  musique.play();
}

void draw() {

  background(0);
  i.afficher();
  // test du pixel, 
  // noir = 0.5 (vitesse à 50%)
  // blanc = 1.5 (vitesse à 150%
  float nouvelle_vitesse=map(i.luminosite, 0, 255, 0.5, 1.5);
  if (abs(nouvelle_vitesse-vitesse)>0.05) {
    vitesse=nouvelle_vitesse;
    musique.rate(vitesse);
    println(vitesse);
  }
  affiche_stats(20, 200);
  i.next_pix();
  delay(50);
}

void mouseClicked(){
  i.next_row();
}